Name:           perl-App-cpanminus
Version:        1.7048
Release:    1%{?dist}
Summary:        Get, unpack, build and install CPAN modules
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/App-cpanminus
Source0:        https://cpan.metacpan.org/authors/id/M/MI/MIYAGAWA/App-cpanminus-%{version}.tar.gz
Source1:        fatunpack
Patch0:         App-cpanminus-1.7044-SHA1-SHA256-in-checksum-chat.patch
BuildArch:      noarch
BuildRequires:  %{_bindir}/podselect
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(Config)
BuildRequires:  perl(constant)
BuildRequires:  perl(CPAN::Meta::Requirements)
BuildRequires:  perl(Cwd)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Copy)
BuildRequires:  perl(File::Find)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(String::ShellQuote)
BuildRequires:  perl(Symbol)
BuildRequires:  perl(version)
BuildRequires:  perl(Test::More)
%if 0%(perl -e 'print $] < 5.026' 2>/dev/null)
Requires:       perl-core
%else
Requires:       perl
%endif
Requires:       perl(CPAN::DistnameInfo)
Requires:       perl(CPAN::Meta)
Requires:       perl(CPAN::Meta::Check) >= 0.018
Requires:       perl(CPAN::Meta::YAML)
Requires:       perl(Digest::SHA)
Requires:       perl(ExtUtils::Install) >= 1.46
Requires:       perl(ExtUtils::MakeMaker) >= 6.58
Requires:       perl(ExtUtils::Manifest)
Requires:       perl(File::pushd)
Requires:       perl(HTTP::Tiny)
Requires:       perl(local::lib)
Requires:       perl(Module::Build) >= 0.38
Requires:       perl(Module::CoreList)
Requires:       perl(Module::CPANfile)
Requires:       perl(Module::Metadata)
Requires:       perl(Parse::PMFile)
Requires:       perl(Safe)
Requires:       perl(YAML)
Provides:       cpanminus = %{version}-%{release}

%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(App::cpanminus\\)$
%global __provides_exclude %{__provides_exclude}|^perl\\(ModuleBuildSkipMan\\)

%description
Why? It's dependency free, requires zero configuration, and stands alone 
but it's maintainable and extensible with plug-ins and friendly to shell 
scripting. When running, it requires only 10 MB of RAM.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n App-cpanminus-%{version}
podselect lib/App/cpanminus.pm > lib/App/cpanminus.pod

for F in bin/cpanm lib/App/cpanminus/fatscript.pm; do
    %{SOURCE1} --libdir lib --filter '^App/cpanminus' "$F" > "${F}.stripped"
    perl -c -Ilib "${F}.stripped"
    mv "${F}.stripped" "$F"
done

%patch -P0 -p1

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/App*
%{_mandir}/man1/cpanm*
%{_mandir}/man3/App::cpanminus*
%{_bindir}/cpanm

%files tests
%{_libexecdir}/%{name}

%changelog
* Tue Nov 05 2024 Fanjun Kong <fanjunkong@tencent.com> - 1.7048-1
- bump 1.7048 and fix CVE-2024-45321

* Wed Jul 24 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.7047-1
- initial build
